diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/flow-monitor/examples/wifi-olsr-flowmon.py ns-3.41/src/flow-monitor/examples/wifi-olsr-flowmon.py
--- ns-3.40/src/flow-monitor/examples/wifi-olsr-flowmon.py	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/flow-monitor/examples/wifi-olsr-flowmon.py	2024-02-09 14:44:07.909790000 -0800
@@ -17,17 +17,25 @@
 #  Authors: Gustavo Carneiro <gjc@inescporto.pt>
 
 from __future__ import print_function
+
 import sys
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
-DISTANCE = 20 # (m)
+DISTANCE = 20  # (m)
 NUM_NODES_SIDE = 3
 
 
 def main(argv):
+    from ctypes import c_bool, c_char_p, c_int, create_string_buffer
 
-    from ctypes import c_int, c_bool, c_char_p, create_string_buffer
     NumNodesSide = c_int(2)
     Plot = c_bool(False)
     BUFFLEN = 4096
@@ -35,7 +43,11 @@
     Results = c_char_p(ResultsBuffer.raw)
 
     cmd = ns.CommandLine(__file__)
-    cmd.AddValue("NumNodesSide", "Grid side number of nodes (total number of nodes will be this number squared)", NumNodesSide)
+    cmd.AddValue(
+        "NumNodesSide",
+        "Grid side number of nodes (total number of nodes will be this number squared)",
+        NumNodesSide,
+    )
     cmd.AddValue("Results", "Write XML results to file", Results, BUFFLEN)
     cmd.AddValue("Plot", "Plot the results using the matplotlib python module", Plot)
     cmd.Parse(argv)
@@ -46,8 +58,7 @@
     wifiChannel = ns.wifi.YansWifiChannelHelper.Default()
     wifiPhy.SetChannel(wifiChannel.Create())
     ssid = ns.wifi.Ssid("wifi-default")
-    wifiMac.SetType ("ns3::AdhocWifiMac",
-                     "Ssid", ns.wifi.SsidValue(ssid))
+    wifiMac.SetType("ns3::AdhocWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
 
     internet = ns.internet.InternetStackHelper()
     list_routing = ns.internet.Ipv4ListRoutingHelper()
@@ -60,12 +71,16 @@
     ipv4Addresses = ns.internet.Ipv4AddressHelper()
     ipv4Addresses.SetBase(ns.network.Ipv4Address("10.0.0.0"), ns.network.Ipv4Mask("255.255.255.0"))
 
-    port = 9   # Discard port(RFC 863)
+    port = 9  # Discard port(RFC 863)
     inetAddress = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.0.0.1"), port)
     onOffHelper = ns.applications.OnOffHelper("ns3::UdpSocketFactory", inetAddress.ConvertTo())
     onOffHelper.SetAttribute("DataRate", ns.network.DataRateValue(ns.network.DataRate("100kbps")))
-    onOffHelper.SetAttribute("OnTime", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=1]"))
-    onOffHelper.SetAttribute("OffTime", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=0]"))
+    onOffHelper.SetAttribute(
+        "OnTime", ns.core.StringValue("ns3::ConstantRandomVariable[Constant=1]")
+    )
+    onOffHelper.SetAttribute(
+        "OffTime", ns.core.StringValue("ns3::ConstantRandomVariable[Constant=0]")
+    )
 
     addresses = []
     nodes = []
@@ -75,18 +90,17 @@
     else:
         num_nodes_side = NumNodesSide.value
 
-    nodes = ns.NodeContainer(num_nodes_side*num_nodes_side)
+    nodes = ns.NodeContainer(num_nodes_side * num_nodes_side)
     accumulator = 0
     for xi in range(num_nodes_side):
         for yi in range(num_nodes_side):
-
             node = nodes.Get(accumulator)
             accumulator += 1
             container = ns.network.NodeContainer(node)
             internet.Install(container)
 
             mobility = ns.CreateObject("ConstantPositionMobilityModel")
-            mobility.SetPosition(ns.core.Vector(xi*DISTANCE, yi*DISTANCE, 0))
+            mobility.SetPosition(ns.core.Vector(xi * DISTANCE, yi * DISTANCE, 0))
             node.AggregateObject(mobility)
 
             device = wifi.Install(wifiPhy, wifiMac, node)
@@ -95,17 +109,20 @@
 
     for i, node in [(i, nodes.Get(i)) for i in range(nodes.GetN())]:
         destaddr = addresses[(len(addresses) - 1 - i) % len(addresses)]
-        #print (i, destaddr)
-        onOffHelper.SetAttribute("Remote", ns.network.AddressValue(ns.network.InetSocketAddress(destaddr, port).ConvertTo()))
+        # print (i, destaddr)
+        onOffHelper.SetAttribute(
+            "Remote",
+            ns.network.AddressValue(ns.network.InetSocketAddress(destaddr, port).ConvertTo()),
+        )
         container = ns.network.NodeContainer(node)
         app = onOffHelper.Install(container)
-        urv = ns.CreateObject("UniformRandomVariable")#ns.cppyy.gbl.get_rng()
+        urv = ns.CreateObject("UniformRandomVariable")  # ns.cppyy.gbl.get_rng()
         startDelay = ns.Seconds(urv.GetValue(20, 30))
         app.Start(startDelay)
 
-    #internet.EnablePcapAll("wifi-olsr")
+    # internet.EnablePcapAll("wifi-olsr")
     flowmon_helper = ns.flow_monitor.FlowMonitorHelper()
-    #flowmon_helper.SetMonitorAttribute("StartTime", ns.core.TimeValue(ns.core.Seconds(31)))
+    # flowmon_helper.SetMonitorAttribute("StartTime", ns.core.TimeValue(ns.core.Seconds(31)))
     monitor = flowmon_helper.InstallAll()
     monitor = flowmon_helper.GetMonitor()
     monitor.SetAttribute("DelayBinWidth", ns.core.DoubleValue(0.001))
@@ -116,33 +133,60 @@
     ns.core.Simulator.Run()
 
     def print_stats(os, st):
-        print ("  Tx Bytes: ", st.txBytes, file=os)
-        print ("  Rx Bytes: ", st.rxBytes, file=os)
-        print ("  Tx Packets: ", st.txPackets, file=os)
-        print ("  Rx Packets: ", st.rxPackets, file=os)
-        print ("  Lost Packets: ", st.lostPackets, file=os)
+        print("  Tx Bytes: ", st.txBytes, file=os)
+        print("  Rx Bytes: ", st.rxBytes, file=os)
+        print("  Tx Packets: ", st.txPackets, file=os)
+        print("  Rx Packets: ", st.rxPackets, file=os)
+        print("  Lost Packets: ", st.lostPackets, file=os)
         if st.rxPackets > 0:
-            print ("  Mean{Delay}: ", (st.delaySum.GetSeconds() / st.rxPackets), file=os)
-            print ("  Mean{Jitter}: ", (st.jitterSum.GetSeconds() / (st.rxPackets-1)), file=os)
-            print ("  Mean{Hop Count}: ", float(st.timesForwarded) / st.rxPackets + 1, file=os)
+            print("  Mean{Delay}: ", (st.delaySum.GetSeconds() / st.rxPackets), file=os)
+            print("  Mean{Jitter}: ", (st.jitterSum.GetSeconds() / (st.rxPackets - 1)), file=os)
+            print("  Mean{Hop Count}: ", float(st.timesForwarded) / st.rxPackets + 1, file=os)
 
         if 0:
-            print ("Delay Histogram", file=os)
-            for i in range(st.delayHistogram.GetNBins () ):
-              print (" ",i,"(", st.delayHistogram.GetBinStart (i), "-", \
-                  st.delayHistogram.GetBinEnd (i), "): ", st.delayHistogram.GetBinCount (i), file=os)
-            print ("Jitter Histogram", file=os)
-            for i in range(st.jitterHistogram.GetNBins () ):
-              print (" ",i,"(", st.jitterHistogram.GetBinStart (i), "-", \
-                  st.jitterHistogram.GetBinEnd (i), "): ", st.jitterHistogram.GetBinCount (i), file=os)
-            print ("PacketSize Histogram", file=os)
-            for i in range(st.packetSizeHistogram.GetNBins () ):
-              print (" ",i,"(", st.packetSizeHistogram.GetBinStart (i), "-", \
-                  st.packetSizeHistogram.GetBinEnd (i), "): ", st.packetSizeHistogram.GetBinCount (i), file=os)
+            print("Delay Histogram", file=os)
+            for i in range(st.delayHistogram.GetNBins()):
+                print(
+                    " ",
+                    i,
+                    "(",
+                    st.delayHistogram.GetBinStart(i),
+                    "-",
+                    st.delayHistogram.GetBinEnd(i),
+                    "): ",
+                    st.delayHistogram.GetBinCount(i),
+                    file=os,
+                )
+            print("Jitter Histogram", file=os)
+            for i in range(st.jitterHistogram.GetNBins()):
+                print(
+                    " ",
+                    i,
+                    "(",
+                    st.jitterHistogram.GetBinStart(i),
+                    "-",
+                    st.jitterHistogram.GetBinEnd(i),
+                    "): ",
+                    st.jitterHistogram.GetBinCount(i),
+                    file=os,
+                )
+            print("PacketSize Histogram", file=os)
+            for i in range(st.packetSizeHistogram.GetNBins()):
+                print(
+                    " ",
+                    i,
+                    "(",
+                    st.packetSizeHistogram.GetBinStart(i),
+                    "-",
+                    st.packetSizeHistogram.GetBinEnd(i),
+                    "): ",
+                    st.packetSizeHistogram.GetBinCount(i),
+                    file=os,
+                )
 
         for reason, drops in enumerate(st.packetsDropped):
-            print ("  Packets dropped by reason %i: %i" % (reason, drops), file=os)
-        #for reason, drops in enumerate(st.bytesDropped):
+            print("  Packets dropped by reason %i: %i" % (reason, drops), file=os)
+        # for reason, drops in enumerate(st.bytesDropped):
         #    print "Bytes dropped by reason %i: %i" % (reason, drops)
 
     monitor.CheckForLostPackets()
@@ -151,17 +195,26 @@
     if Results.value != b"output.xml":
         for flow_id, flow_stats in monitor.GetFlowStats():
             t = classifier.FindFlow(flow_id)
-            proto = {6: 'TCP', 17: 'UDP'} [t.protocol]
-            print ("FlowID: %i (%s %s/%s --> %s/%i)" % \
-                (flow_id, proto, t.sourceAddress, t.sourcePort, t.destinationAddress, t.destinationPort))
+            proto = {6: "TCP", 17: "UDP"}[t.protocol]
+            print(
+                "FlowID: %i (%s %s/%s --> %s/%i)"
+                % (
+                    flow_id,
+                    proto,
+                    t.sourceAddress,
+                    t.sourcePort,
+                    t.destinationAddress,
+                    t.destinationPort,
+                )
+            )
             print_stats(sys.stdout, flow_stats)
     else:
         res = monitor.SerializeToXmlFile(Results.value.decode("utf-8"), True, True)
-        print (res)
-
+        print(res)
 
     if Plot.value:
         import pylab
+
         delays = []
         for flow_id, flow_stats in monitor.GetFlowStats():
             tupl = classifier.FindFlow(flow_id)
@@ -176,6 +229,5 @@
     return 0
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     sys.exit(main(sys.argv))
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/CMakeLists.txt ns-3.41/src/internet/CMakeLists.txt
--- ns-3.40/src/internet/CMakeLists.txt	2023-09-27 13:30:37.650839000 -0700
+++ ns-3.41/src/internet/CMakeLists.txt	2024-02-09 14:44:07.917790200 -0800
@@ -129,7 +129,6 @@
 )
 
 set(header_files
-    ${header_files}
     helper/internet-stack-helper.h
     helper/internet-trace-helper.h
     helper/ipv4-address-helper.h
@@ -341,10 +340,7 @@
   SOURCE_FILES ${source_files}
   HEADER_FILES ${header_files}
   PRIVATE_HEADER_FILES ${private_header_files}
-  LIBRARIES_TO_LINK
-    ${libnetwork}
-    ${libcore}
-    ${libbridge}
-    ${libtraffic-control}
+  LIBRARIES_TO_LINK ${libbridge}
+                    ${libtraffic-control}
   TEST_SOURCES ${test_sources}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/arp-l3-protocol.cc ns-3.41/src/internet/model/arp-l3-protocol.cc
--- ns-3.40/src/internet/model/arp-l3-protocol.cc	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/arp-l3-protocol.cc	2024-02-09 14:44:07.921790100 -0800
@@ -191,7 +191,7 @@
     //
     // If we're connected to a real world network, then some of the fields sizes
     // in an ARP packet can vary in ways not seen in simulations.  We need to be
-    // able to detect ARP packets with headers we don't recongnize and not process
+    // able to detect ARP packets with headers we don't recognize and not process
     // them instead of crashing.  The ArpHeader will return 0 if it can't deal
     // with the received header.
     //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/global-routing.h ns-3.41/src/internet/model/global-routing.h
--- ns-3.40/src/internet/model/global-routing.h	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/global-routing.h	2024-02-09 14:44:07.925790300 -0800
@@ -82,6 +82,6 @@
  * By using a standard data format for reporting topology, existing
  * OSPF route computation code can be reused, and that is what is done
  * by the ns3::GlobalRouteManager.  The main computation functions are
- * ported from the quagga routing suite (http://www.quagga.net).
+ * ported from the quagga routing suite (https://www.nongnu.org/quagga/).
  *
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/icmpv4-l4-protocol.cc ns-3.41/src/internet/model/icmpv4-l4-protocol.cc
--- ns-3.40/src/internet/model/icmpv4-l4-protocol.cc	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/icmpv4-l4-protocol.cc	2024-02-09 14:44:07.925790300 -0800
@@ -222,14 +222,18 @@
 Icmpv4L4Protocol::HandleEcho(Ptr<Packet> p,
                              Icmpv4Header header,
                              Ipv4Address source,
-                             Ipv4Address destination)
+                             Ipv4Address destination,
+                             uint8_t tos)
 {
-    NS_LOG_FUNCTION(this << p << header << source << destination);
+    NS_LOG_FUNCTION(this << p << header << source << destination << tos);
 
     Ptr<Packet> reply = Create<Packet>();
     Icmpv4Echo echo;
     p->RemoveHeader(echo);
     reply->AddHeader(echo);
+    SocketIpTosTag ipTosTag;
+    ipTosTag.SetTos(tos);
+    reply->ReplacePacketTag(ipTosTag);
     SendMessage(reply, destination, source, Icmpv4Header::ICMPV4_ECHO_REPLY, 0, nullptr);
 }
 
@@ -327,7 +331,7 @@
                 }
             }
         }
-        HandleEcho(p, icmp, header.GetSource(), dst);
+        HandleEcho(p, icmp, header.GetSource(), dst, header.GetTos());
         break;
     }
     case Icmpv4Header::ICMPV4_DEST_UNREACH:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/icmpv4-l4-protocol.h ns-3.41/src/internet/model/icmpv4-l4-protocol.h
--- ns-3.40/src/internet/model/icmpv4-l4-protocol.h	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/icmpv4-l4-protocol.h	2024-02-09 14:44:07.925790300 -0800
@@ -143,11 +143,13 @@
      * \param header the IP header
      * \param source the source address
      * \param destination the destination address
+     * \param tos the type of service
      */
     void HandleEcho(Ptr<Packet> p,
                     Icmpv4Header header,
                     Ipv4Address source,
-                    Ipv4Address destination);
+                    Ipv4Address destination,
+                    uint8_t tos);
     /**
      * \brief Handles an incoming ICMP Destination Unreachable packet
      * \param p the packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/icmpv6-l4-protocol.cc ns-3.41/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.40/src/internet/model/icmpv6-l4-protocol.cc	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/icmpv6-l4-protocol.cc	2024-02-09 14:44:07.925790300 -0800
@@ -1250,7 +1250,7 @@
     NS_LOG_LOGIC("Send NA ( from " << src << " to " << dst << " target " << src << ")");
     na.SetIpv6Target(src);
 
-    if ((flags & 1))
+    if (flags & 1)
     {
         na.SetFlagO(true);
     }
@@ -1258,7 +1258,7 @@
     {
         na.SetFlagS(true);
     }
-    if ((flags & 4))
+    if (flags & 4)
     {
         na.SetFlagR(true);
     }
@@ -1618,7 +1618,7 @@
     p->AddHeader(llOption);
     na.SetIpv6Target(src);
 
-    if ((flags & 1))
+    if (flags & 1)
     {
         na.SetFlagO(true);
     }
@@ -1626,7 +1626,7 @@
     {
         na.SetFlagS(true);
     }
-    if ((flags & 4))
+    if (flags & 4)
     {
         na.SetFlagR(true);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4.cc ns-3.41/src/internet/model/ipv4.cc
--- ns-3.40/src/internet/model/ipv4.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv4.cc	2024-02-09 14:44:07.929790300 -0800
@@ -23,6 +23,7 @@
 #include "ns3/boolean.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
+#include "ns3/warnings.h"
 
 namespace ns3
 {
@@ -34,6 +35,7 @@
 TypeId
 Ipv4::GetTypeId()
 {
+    NS_WARNING_PUSH_DEPRECATED;
     static TypeId tid =
         TypeId("ns3::Ipv4")
             .SetParent<Object>()
@@ -49,7 +51,16 @@
                           "another interface",
                           BooleanValue(true),
                           MakeBooleanAccessor(&Ipv4::SetWeakEsModel, &Ipv4::GetWeakEsModel),
-                          MakeBooleanChecker())
+                          MakeBooleanChecker(),
+                          TypeId::DEPRECATED,
+                          "DEPRECATED since ns-3.41. Use the StrongEndSystemModel attribute.")
+            .AddAttribute(
+                "StrongEndSystemModel",
+                "Reject packets for an address not configured on the interface they're "
+                "coming from (RFC1122, section 3.3.4.2).",
+                BooleanValue(false),
+                MakeBooleanAccessor(&Ipv4::SetStrongEndSystemModel, &Ipv4::GetStrongEndSystemModel),
+                MakeBooleanChecker())
 #if 0
     .AddAttribute ("MtuDiscover", "If enabled, every outgoing ip packet will have the DF flag set.",
                    BooleanValue (false),
@@ -58,6 +69,7 @@
                    MakeBooleanChecker ())
 #endif
         ;
+    NS_WARNING_POP;
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4.h ns-3.41/src/internet/model/ipv4.h
--- ns-3.40/src/internet/model/ipv4.h	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv4.h	2024-02-09 14:44:07.933790200 -0800
@@ -23,6 +23,7 @@
 #include "ipv4-route.h"
 
 #include "ns3/callback.h"
+#include "ns3/deprecated.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/object.h"
 #include "ns3/socket.h"
@@ -220,9 +221,9 @@
      * a multicast group that the host has joined (and the incoming device
      * is acceptable), or if address corresponds to a broadcast address.
      *
-     * If the Ipv4 attribute WeakEsModel is true, the unicast address may
-     * match any of the Ipv4 addresses on any interface.  If the attribute is
-     * false, the address must match one assigned to the incoming device.
+     * If the Ipv4 attribute StrongEndSystemModel is true, the address must match one assigned to
+     * the incoming device. If the attribute is false, the unicast address may match any of the Ipv4
+     * addresses on any interface.
      */
     virtual bool IsDestinationAddress(Ipv4Address address, uint32_t iif) const = 0;
 
@@ -455,19 +456,39 @@
     virtual bool GetIpForward() const = 0;
 
     /**
+     * \brief Get the Weak Es Model status
+     *
+     * RFC1122 term for whether host accepts datagram with a dest. address on another interface
+     * \returns true for Weak Es Model activated
+     * \deprecated Deprecated since ns-3.41. Use SetStrongEndSystemModel instead.
+     */
+    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
+    virtual bool GetWeakEsModel() const = 0;
+
+    /**
      * \brief Set or unset the Weak Es Model
      *
      * RFC1122 term for whether host accepts datagram with a dest. address on another interface
      * \param model true for Weak Es Model
+     * \deprecated Deprecated since ns-3.41. Use SetStrongEndSystemModel instead.
      */
+    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
     virtual void SetWeakEsModel(bool model) = 0;
+
     /**
-     * \brief Get the Weak Es Model status
+     * \brief Set or unset the Strong End System Model
      *
-     * RFC1122 term for whether host accepts datagram with a dest. address on another interface
-     * \returns true for Weak Es Model activated
+     * RFC1122 term for whether host rejects datagram with a dest. address on another interface
+     * \param model true for Strong End System Model
      */
-    virtual bool GetWeakEsModel() const = 0;
+    virtual void SetStrongEndSystemModel(bool model) = 0;
+    /**
+     * \brief Get the Strong End System Model status
+     *
+     * RFC1122 term for whether host rejects datagram with a dest. address on another interface
+     * \returns true for Strong End System Model activated
+     */
+    virtual bool GetStrongEndSystemModel() const = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4-interface.cc ns-3.41/src/internet/model/ipv4-interface.cc
--- ns-3.40/src/internet/model/ipv4-interface.cc	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/ipv4-interface.cc	2024-02-09 14:44:07.925790300 -0800
@@ -237,12 +237,14 @@
         if (dest == (*i).GetLocal())
         {
             p->AddHeader(hdr);
-            m_tc->Receive(m_device,
-                          p,
-                          Ipv4L3Protocol::PROT_NUMBER,
-                          m_device->GetBroadcast(),
-                          m_device->GetBroadcast(),
-                          NetDevice::PACKET_HOST);
+            Simulator::ScheduleNow(&TrafficControlLayer::Receive,
+                                   m_tc,
+                                   m_device,
+                                   p,
+                                   Ipv4L3Protocol::PROT_NUMBER,
+                                   m_device->GetBroadcast(),
+                                   m_device->GetBroadcast(),
+                                   NetDevice::PACKET_HOST);
             return;
         }
     }
@@ -349,7 +351,7 @@
         NS_FATAL_ERROR("index " << index << " out of bounds");
     }
     Ipv4InterfaceAddress addr;
-    return (addr); // quiet compiler
+    return addr; // quiet compiler
 }
 
 Ipv4InterfaceAddress
@@ -379,7 +381,7 @@
     }
     NS_FATAL_ERROR("Address " << index << " not found");
     Ipv4InterfaceAddress addr;
-    return (addr); // quiet compiler
+    return addr; // quiet compiler
 }
 
 Ipv4InterfaceAddress
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4-l3-protocol.cc ns-3.41/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.40/src/internet/model/ipv4-l3-protocol.cc	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/ipv4-l3-protocol.cc	2024-02-09 14:44:07.929790300 -0800
@@ -546,7 +546,7 @@
         return true;
     }
 
-    if (GetWeakEsModel()) // Check other interfaces
+    if (!GetStrongEndSystemModel()) // Check other interfaces
     {
         for (uint32_t j = 0; j < GetNInterfaces(); j++)
         {
@@ -1441,14 +1441,28 @@
 Ipv4L3Protocol::SetWeakEsModel(bool model)
 {
     NS_LOG_FUNCTION(this << model);
-    m_weakEsModel = model;
+    m_strongEndSystemModel = !model;
 }
 
 bool
 Ipv4L3Protocol::GetWeakEsModel() const
 {
     NS_LOG_FUNCTION(this);
-    return m_weakEsModel;
+    return !m_strongEndSystemModel;
+}
+
+void
+Ipv4L3Protocol::SetStrongEndSystemModel(bool model)
+{
+    NS_LOG_FUNCTION(this << model);
+    m_strongEndSystemModel = model;
+}
+
+bool
+Ipv4L3Protocol::GetStrongEndSystemModel() const
+{
+    NS_LOG_FUNCTION(this);
+    return m_strongEndSystemModel;
 }
 
 void
@@ -1880,7 +1894,7 @@
 
     auto iter = --m_timeoutEventList.end();
 
-    return (iter);
+    return iter;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4-l3-protocol.h ns-3.41/src/internet/model/ipv4-l3-protocol.h
--- ns-3.40/src/internet/model/ipv4-l3-protocol.h	2023-09-27 13:30:37.654839000 -0700
+++ ns-3.41/src/internet/model/ipv4-l3-protocol.h	2024-02-09 14:44:07.929790300 -0800
@@ -24,6 +24,7 @@
 #include "ipv4-routing-protocol.h"
 #include "ipv4.h"
 
+#include "ns3/deprecated.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/net-device.h"
 #include "ns3/nstime.h"
@@ -295,9 +296,15 @@
     // class Ipv4 attributes
     void SetIpForward(bool forward) override;
     bool GetIpForward() const override;
+
+    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
     void SetWeakEsModel(bool model) override;
+    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
     bool GetWeakEsModel() const override;
 
+    void SetStrongEndSystemModel(bool model) override;
+    bool GetStrongEndSystemModel() const override;
+
     /**
      * \brief Decrease the identification value for a dropped or recursed packet
      * \param source source IPv4 address
@@ -460,7 +467,7 @@
     typedef std::map<L4ListKey_t, Ptr<IpL4Protocol>> L4List_t;
 
     bool m_ipForward;               //!< Forwarding packets (i.e. router mode) state.
-    bool m_weakEsModel;             //!< Weak ES model state
+    bool m_strongEndSystemModel;    //!< Strong End System Model state
     L4List_t m_protocols;           //!< List of transport protocol.
     Ipv4InterfaceList m_interfaces; //!< List of IPv4 interfaces.
     Ipv4InterfaceReverseContainer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4-raw-socket-impl.cc ns-3.41/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.40/src/internet/model/ipv4-raw-socket-impl.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv4-raw-socket-impl.cc	2024-02-09 14:44:07.929790300 -0800
@@ -135,7 +135,7 @@
 Ipv4RawSocketImpl::Bind6()
 {
     NS_LOG_FUNCTION(this);
-    return (-1);
+    return -1;
 }
 
 int
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv4-route.cc ns-3.41/src/internet/model/ipv4-route.cc
--- ns-3.40/src/internet/model/ipv4-route.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv4-route.cc	2024-02-09 14:44:07.929790300 -0800
@@ -167,7 +167,7 @@
 Ipv4MulticastRoute::GetOutputTtlMap() const
 {
     NS_LOG_FUNCTION(this);
-    return (m_ttls);
+    return m_ttls;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-address-generator.cc ns-3.41/src/internet/model/ipv6-address-generator.cc
--- ns-3.40/src/internet/model/ipv6-address-generator.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-address-generator.cc	2024-02-09 14:44:07.933790200 -0800
@@ -553,7 +553,7 @@
             taddr[j] = (*i).addrLow[j];
         }
         taddr[15] -= 1;
-        if ((Ipv6Address(addr) == Ipv6Address(taddr)))
+        if (Ipv6Address(addr) == Ipv6Address(taddr))
         {
             NS_LOG_LOGIC("New addrLow = " << Ipv6Address(addr));
             for (uint32_t j = 0; j < 16; j++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6.cc ns-3.41/src/internet/model/ipv6.cc
--- ns-3.40/src/internet/model/ipv6.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6.cc	2024-02-09 14:44:07.933790200 -0800
@@ -47,7 +47,14 @@
                           "If disabled, every interface will have its MTU set to 1280 bytes.",
                           BooleanValue(true),
                           MakeBooleanAccessor(&Ipv6::SetMtuDiscover, &Ipv6::GetMtuDiscover),
-                          MakeBooleanChecker());
+                          MakeBooleanChecker())
+            .AddAttribute(
+                "StrongEndSystemModel",
+                "Reject packets for an address not configured on the interface they're "
+                "coming from (RFC1122, section 3.3.4.2).",
+                BooleanValue(true),
+                MakeBooleanAccessor(&Ipv6::SetStrongEndSystemModel, &Ipv6::GetStrongEndSystemModel),
+                MakeBooleanChecker());
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-extension.cc ns-3.41/src/internet/model/ipv6-extension.cc
--- ns-3.40/src/internet/model/ipv6-extension.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-extension.cc	2024-02-09 14:44:07.933790200 -0800
@@ -686,7 +686,7 @@
 
     auto iter = --m_timeoutEventList.end();
 
-    return (iter);
+    return iter;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6.h ns-3.41/src/internet/model/ipv6.h
--- ns-3.40/src/internet/model/ipv6.h	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6.h	2024-02-09 14:44:07.933790200 -0800
@@ -424,6 +424,21 @@
      * \return MTU discover state (enabled or not)
      */
     virtual bool GetMtuDiscover() const = 0;
+
+    /**
+     * \brief Set or unset the Strong End System Model
+     *
+     * RFC1122 term for whether host rejects datagram with a dest. address on another interface
+     * \param model true for Strong End System Model
+     */
+    virtual void SetStrongEndSystemModel(bool model) = 0;
+    /**
+     * \brief Get the Strong End System Model status
+     *
+     * RFC1122 term for whether host rejects datagram with a dest. address on another interface
+     * \returns true for Strong End System Model activated
+     */
+    virtual bool GetStrongEndSystemModel() const = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-interface.cc ns-3.41/src/internet/model/ipv6-interface.cc
--- ns-3.40/src/internet/model/ipv6-interface.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-interface.cc	2024-02-09 14:44:07.933790200 -0800
@@ -435,12 +435,14 @@
         if (dest == it->first.GetAddress())
         {
             p->AddHeader(hdr);
-            m_tc->Receive(m_device,
-                          p,
-                          Ipv6L3Protocol::PROT_NUMBER,
-                          m_device->GetBroadcast(),
-                          m_device->GetBroadcast(),
-                          NetDevice::PACKET_HOST);
+            Simulator::ScheduleNow(&TrafficControlLayer::Receive,
+                                   m_tc,
+                                   m_device,
+                                   p,
+                                   Ipv6L3Protocol::PROT_NUMBER,
+                                   m_device->GetBroadcast(),
+                                   m_device->GetBroadcast(),
+                                   NetDevice::PACKET_HOST);
             return;
         }
     }
